<?php
namespace Teknisa\CADEST\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class ComposicaoProdutoService {
    protected $connection;

    public function __construct($entityManager) {
        $this->connection = $entityManager->getConnection();
        date_default_timezone_set('America/Sao_Paulo');
    }
    
    public function find($row){
      $search = NULL;
      $indexFind = 'CDARVPROD|NMPRODUTO|SGUNIDADE|DTINIVGPROMOC|DTFINVGPROMOC';
      
      $keys = array_keys($row);
      $indexKey = '';
      $found = false;
      foreach ($keys as $key) {
          if (gettype(strpos($indexFind, $key)) == 'integer') {
              $found = true;
              $indexKey = $key;
          }
      }
      
      if($found){
          if(gettype($row[$indexKey]) == 'string')
           $search = $row[$indexKey];
          else 
           $search = $row[$indexKey][0]['_ALL'];
      }
       $param = array(
                ':CDFILIAL'     => $row['CDFILIAL'],
                ':P_PRODINI'    => $row['P_PRODINI'],
                ':P_PRODFIN'    => $row['P_PRODFIN'],
                ':CDPRODUTO'    => $row['CDPRODUTO'],
                ':CDNVPRODUTO'  => $row['CDNVPRODUTO'],
                ':IDTIPOCOMPPROD' => $row['NMTIPOCOMPPROD'] ,
                ':NRCOMPPRODFLAG' => array_key_exists('NRCOMPPRODFLAG', $row ) ? $row['NRCOMPPRODFLAG'] : '',
                ':CDSEGMER'     => $row['CDSEGMER'],
                ':SEARCH'       => $search
           );
        return $this->connection->fetchAll(self::FIND, $param);
    }
   
   public function checkIsNewPadrao($row){
     $params = array(
       'CDPRODUTO' => $row['CDPRODUTO']
      );
      
      return $this->connection->fetchAssoc(self::CHECK_ISNEW_PADRAO, $params)['COUNT'];
   }
   public function checkIsNewLocal($row){
     $params = array(
       'CDPRODUTO' => $row['CDPRODUTO'],
       'CDFILIAL'  => $row['CDFILIAL']
      );
      
      return $this->connection->fetchAssoc(self::CHECK_ISNEW_LOCAL, $params)['COUNT'];
   }
   
   const CHECK_ISNEW_LOCAL = "
      SELECT COUNT(*) AS COUNT FROM DESCROTLOCAL
      WHERE CDPRODUTO = :CDPRODUTO
      AND CDFILIAL = :CDFILIAL
      ";
      
   const CHECK_ISNEW_PADRAO = "
      SELECT COUNT(*) AS COUNT FROM DESCROTEIRO
      WHERE CDPRODUTO = :CDPRODUTO
      ";
   
   const FIND = "

   SELECT
   SUM(T.NRCOMPPROD) AS NRCOMPPROD,
   T.CDPRODUTO, T.CDARVPROD, T.NMPRODUTO,
   T.SGUNIDADE, T.IDIMPPRODUTO, T.IDTIPOCOMPPROD, T.DTINIVGPROMOC, T.DTFINVGPROMOC, T.IDUTILRETPRODACAB, T.DSAPELIDOKDS
FROM
  (SELECT P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, P.SGUNIDADE, P.IDIMPPRODUTO, P.IDTIPOCOMPPROD, P.DTINIVGPROMOC, P.DTFINVGPROMOC,
          NVL(NVL(R.NRCOMPPROD, 0) + NVL(F.NRCOMPPRODL, 0) + NVL(G.NRCOMPPROD, 0) + NVL(L.NRCOMPPRODL, 0), 0) AS NRCOMPPROD, P.IDUTILRETPRODACAB, P.DSAPELIDOKDS
   FROM PRODUTO P, PRODUTOSEG S,
        (SELECT COUNT(*) AS NRCOMPPROD, CDPRODUTO
         FROM ROTFABRICA
         GROUP BY CDPRODUTO) R,
        (SELECT COUNT(*) AS NRCOMPPRODL, CDPRODUTO
         FROM ROTFABLOCAL
         WHERE (CDFILIAL = :CDFILIAL)
         GROUP BY CDPRODUTO) F,
        (SELECT COUNT(*) AS NRCOMPPROD, CDPRODPROMOCAO
         FROM GRUPROMOCPROD
         GROUP BY CDPRODPROMOCAO) G,
        (SELECT COUNT(*) AS NRCOMPPRODL, CDPRODPROMOCAO
         FROM GRUPROMOCPRFIL
         WHERE (CDFILIAL = :CDFILIAL)
         GROUP BY CDPRODPROMOCAO) L
   WHERE (NVL(P.IDPRODATIVPR,'S') = 'S') AND
         ((P.CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIN) OR (:CDPRODUTO = 'S') OR (INSTR(:CDPRODUTO, P.CDPRODUTO) >0)) AND
         (P.CDNVPRODUTO = :CDNVPRODUTO) AND
         ((INSTR(:IDTIPOCOMPPROD, IDTIPOCOMPPROD) >0) OR (:IDTIPOCOMPPROD = 'S')) AND
         (S.CDPRODUTO = P.CDPRODUTO) AND
         (NVL(S.IDPROSEGATIV, 'S') = 'S') AND
         (S.CDSEGMER = :CDSEGMER) AND
         (R.CDPRODUTO(+) = P.CDPRODUTO) AND
         (F.CDPRODUTO(+) = P.CDPRODUTO) AND
         (G.CDPRODPROMOCAO(+) = P.CDPRODUTO) AND
         (L.CDPRODPROMOCAO(+) = P.CDPRODUTO)
   UNION
   SELECT P.CDPRODUTO, P.CDARVPROD, P.NMPRODUTO, P.SGUNIDADE, P.IDIMPPRODUTO, P.IDTIPOCOMPPROD, P.DTINIVGPROMOC, P.DTFINVGPROMOC,
          NVL(NVL(R.NRCOMPPROD, 0) + NVL(F.NRCOMPPRODL, 0) + NVL(G.NRCOMPPROD, 0) + NVL(L.NRCOMPPRODL, 0), 0) AS NRCOMPPROD, P.IDUTILRETPRODACAB, P.DSAPELIDOKDS
   FROM PRODUTO P,
        (SELECT COUNT(*) AS NRCOMPPROD, CDPRODUTO
         FROM ROTFABRICA
         WHERE (:CDSEGMER = 'T')
         GROUP BY CDPRODUTO) R,
        (SELECT COUNT(*) AS NRCOMPPRODL, CDPRODUTO
         FROM ROTFABLOCAL
         WHERE (CDFILIAL = :CDFILIAL) AND
               (:CDSEGMER = 'T')
         GROUP BY CDPRODUTO) F,
        (SELECT COUNT(*) AS NRCOMPPROD, CDPRODPROMOCAO
         FROM GRUPROMOCPROD
         WHERE (:CDSEGMER = 'T')
         GROUP BY CDPRODPROMOCAO) G,
        (SELECT COUNT(*) AS NRCOMPPRODL, CDPRODPROMOCAO
         FROM GRUPROMOCPRFIL
         WHERE (CDFILIAL = :CDFILIAL) AND
               (:CDSEGMER = 'T')
         GROUP BY CDPRODPROMOCAO) L
   WHERE (NVL(P.IDPRODATIVPR,'S') = 'S') AND
         ((P.CDARVPROD BETWEEN :P_PRODINI AND :P_PRODFIN) OR (:CDPRODUTO = 'S') OR (INSTR(:CDPRODUTO, P.CDPRODUTO) >0)) AND
         (P.CDNVPRODUTO = :CDNVPRODUTO) AND
         ((INSTR(:IDTIPOCOMPPROD, IDTIPOCOMPPROD) >0) OR (:IDTIPOCOMPPROD = 'S')) AND
         (:CDSEGMER = 'T') AND
         (R.CDPRODUTO(+) = P.CDPRODUTO) AND
         (F.CDPRODUTO(+) = P.CDPRODUTO) AND
         (G.CDPRODPROMOCAO(+) = P.CDPRODUTO) AND
         (L.CDPRODPROMOCAO(+) = P.CDPRODUTO) ) T
         
         WHERE (UPPER(T.CDARVPROD||T.NMPRODUTO||T.SGUNIDADE||T.DTINIVGPROMOC||T.DTFINVGPROMOC) LIKE UPPER(:SEARCH) OR :SEARCH IS NULL)
GROUP BY
   T.CDPRODUTO, T.CDARVPROD, T.NMPRODUTO,
   T.SGUNIDADE, T.IDIMPPRODUTO, T.IDTIPOCOMPPROD, T.DTINIVGPROMOC, T.DTFINVGPROMOC, T.IDUTILRETPRODACAB, T.DSAPELIDOKDS
HAVING ((SUM(T.NRCOMPPROD) >= 0 AND :NRCOMPPRODFLAG = 'T') OR (SUM(T.NRCOMPPROD) > 0 AND :NRCOMPPRODFLAG = 'S') 
OR (SUM(T.NRCOMPPROD) = 0 AND :NRCOMPPRODFLAG = 'N'))


ORDER BY T.CDARVPROD";
}
        
  